/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.105 Revision 1.282
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.105 2005/02/27 03:27:52 plasmaroo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.282 2013/04/17 13:52:17 tomwij Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2005 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
22# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# the patchset version for 31# the patchset version for
30# and not use it as a true package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36# 39#
37# K_DEFCONFIG - Allow specifying a different defconfig target. If length zero, 40# K_DEFCONFIG - Allow specifying a different defconfig target.
38# defaults to "defconfig". 41# If length zero, defaults to "defconfig".
39 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
40# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
41# can be supported by the headers ebuild 59# can be supported by the headers ebuild
42 60
43# UNIPATCH_LIST - space delimetered list of patches to be applied to the 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
44# kernel 62# kernel
49# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
50# the doc dir 68# the doc dir
51# UNIPATCH_STRICTORDER - if this is set places patches into directories of 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
52# order, so they are applied in the order passed 70# order, so they are applied in the order passed
53 71
72# Changing any other variable in this eclass is not supported; you can request
73# for additional variables to be added by contacting the current maintainer.
74# If you do change them, there is a chance that we will not fix resulting bugs;
75# that of course does not mean we're not willing to help.
76
54inherit toolchain-funcs versionator multilib 77inherit eutils toolchain-funcs versionator multilib
55ECLASS="kernel-2" 78EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
56INHERITED="$INHERITED $ECLASS" 79
57EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 80# Added by Daniel Ostrow <dostrow@gentoo.org>
58 pkg_preinst pkg_postinst 81# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
82# I will remove it when I come up with something more reasonable.
83[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
59 84
60export CTARGET=${CTARGET:-${CHOST}} 85export CTARGET=${CTARGET:-${CHOST}}
61if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 86if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
62 export CTARGET=${CATEGORY/cross-} 87 export CTARGET=${CATEGORY/cross-}
63fi 88fi
64 89
65HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 90HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
66LICENSE="GPL-2" 91: ${LICENSE:="GPL-2"}
92
93# This is the latest KV_PATCH of the deblob tool available from the
94# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
95# for ALL kernel-2 consumer packages where deblob is available.
96: ${DEBLOB_MAX_VERSION:=38}
97
98# No need to run scanelf/strip on kernel sources/headers (bug #134453).
99RESTRICT="binchecks strip"
67 100
68# set LINUX_HOSTCFLAGS if not already set 101# set LINUX_HOSTCFLAGS if not already set
69[ -z "$LINUX_HOSTCFLAGS" ] && \
70 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 102: ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
103
104# debugging functions
105#==============================================================
106# this function exists only to help debug kernel-2.eclass
107# if you are adding new functionality in, put a call to it
108# at the start of src_unpack, or during SRC_URI/dep generation.
109debug-print-kernel2-variables() {
110 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
111 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
112 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
113 debug-print "${v}: ${!v}"
114 done
115}
71 116
72#Eclass functions only from here onwards ... 117#Eclass functions only from here onwards ...
73#============================================================== 118#==============================================================
74kernel_is() { 119handle_genpatches() {
75 [[ -z ${OKV} ]] && return 1 120 local tarball
76 local operator test value x=0 y=0 z=0 121 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
77 122
78 case ${1} in 123 debug-print "Inside handle_genpatches"
79 lt) operator="-lt"; shift;; 124 local OKV_ARRAY
80 gt) operator="-gt"; shift;; 125 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
81 le) operator="-le"; shift;;
82 ge) operator="-ge"; shift;;
83 eq) operator="-eq"; shift;;
84 *) operator="-eq";;
85 esac
86 126
87 for x in ${@}; do 127 # for > 3.0 kernels, handle genpatches tarball name
88 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 128 # genpatches for 3.0 and 3.0.1 might be named
89 value="${value}${x}" 129 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
90 z=$((${z} + 1)) 130 # respectively. Handle this.
91 131
92 case ${z} in 132 for i in ${K_WANT_GENPATCHES} ; do
93 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done; 133 if [[ ${KV_MAJOR} -ge 3 ]]; then
94 test="${test}${KV_MAJOR}";; 134 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
95 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done; 135 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
96 test="${test}${KV_MINOR}";; 136 else
97 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done; 137 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
98 test="${test}${KV_PATCH}";; 138 fi
99 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 139 else
100 esac 140 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
141 fi
142 debug-print "genpatches tarball: $tarball"
143 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
144 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
101 done 145 done
102
103 [ ${test} ${operator} ${value} ] && return 0 || return 1
104}
105
106
107kernel_is_2_4() {
108 kernel_is 2 4
109}
110
111kernel_is_2_6() {
112 kernel_is 2 6 || kernel_is 2 5
113}
114
115kernel_header_destdir() {
116 [[ ${CTARGET} == ${CHOST} ]] \
117 && echo /usr/include \
118 || echo /usr/${CTARGET}/include
119}
120
121# Capture the sources type and set DEPENDs
122if [[ ${ETYPE} == sources ]]; then
123 DEPEND="!build? ( sys-apps/sed
124 >=sys-devel/binutils-2.11.90.0.31 )
125 doc? ( app-text/docbook-sgml-utils )"
126 RDEPEND="${DEPEND}
127 !build? ( >=sys-libs/ncurses-5.2
128 sys-devel/make )"
129
130 PROVIDE="virtual/linux-sources"
131 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
132 SLOT="${PVR}"
133 DESCRIPTION="Sources for the Linux kernel"
134 IUSE="${IUSE} symlink build doc"
135elif [[ ${ETYPE} == headers ]]; then
136 DESCRIPTION="Linux system headers"
137 IUSE="${IUSE}"
138
139 if [[ ${CTARGET} = ${CHOST} ]]; then
140 DEPEND="!virtual/os-headers"
141 PROVIDE="virtual/kernel virtual/os-headers"
142 SLOT="0"
143 else
144 SLOT="${CTARGET}"
145 fi
146else
147 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
148 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
149fi
150
151# Unpack functions
152#==============================================================
153unpack_2_4() {
154 cd ${S}
155 # this file is required for other things to build properly,
156 # so we autogenerate it
157 make mrproper || die "make mrproper died"
158 make include/linux/version.h || die "make include/linux/version.h failed"
159 echo ">>> version.h compiled successfully."
160}
161
162universal_unpack() {
163 cd ${WORKDIR}
164 unpack linux-${OKV}.tar.bz2
165 if [[ "${OKV}" != "${KV_FULL}" ]]; then
166 mv linux-${OKV} linux-${KV_FULL} \
167 || die "Unable to move source tree to ${KV_FULL}."
168 fi
169 cd ${S}
170
171 # remove all backup files
172 find . -iname "*~" -exec rm {} \; 2> /dev/null
173
174 if [[ -d ${S}/Documentation/DocBook ]]; then
175 cd ${S}/Documentation/DocBook
176 sed -ie "s:db2:docbook2:g" Makefile
177 cd ${OLDPWD}
178 fi
179
180 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
181 use ppc && \
182 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
183 ${S}/arch/ppc/Makefile
184}
185
186unpack_set_extraversion() {
187 cd ${S}
188 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
189 cd ${OLDPWD}
190}
191
192# Should be done after patches have been applied
193# Otherwise patches that modify the same area of Makefile will fail
194unpack_fix_install_path() {
195 cd ${S}
196 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
197}
198
199# Compile Functions
200#==============================================================
201compile_headers() {
202 # if we couldnt obtain HOSTCFLAGS from the Makefile,
203 # then set it to something sane
204 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS ${S}/Makefile)
205 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
206
207 # Kernel ARCH != portage ARCH
208 local KARCH=$(tc-arch-kernel)
209
210 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
211 # variables properly or bad things happen !
212 local xmakeopts="ARCH=${KARCH}"
213 if [[ ${CTARGET} != ${CHOST} ]]; then
214 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
215 elif type -p ${CHOST}-ar; then
216 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
217 fi
218
219 if kernel_is 2 4; then
220 yes "" | make oldconfig ${xmakeopts}
221 echo ">>> make oldconfig complete"
222 use sparc && make dep ${xmakeopts}
223 elif kernel_is 2 6; then
224 # autoconf.h isnt generated unless it already exists. plus, we have
225 # no guarantee that any headers are installed on the system...
226 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
227 || touch include/linux/autoconf.h
228
229 # if K_DEFCONFIG isn't set, force to "defconfig"
230 # needed by mips
231 if [[ -z ${K_DEFCONFIG} ]]; then
232 K_DEFCONFIG="defconfig"
233 fi
234
235 # if there arent any installed headers, then there also isnt an asm
236 # symlink in /usr/include/, and make defconfig will fail, so we have
237 # to force an include path with $S.
238 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
239 ln -sf asm-${KARCH} "${S}"/include/asm
240 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed"
241 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
242 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
243 fi
244}
245
246compile_manpages() {
247 einfo "Making manpages ..."
248 env -u ARCH make mandocs
249}
250
251# install functions
252#==============================================================
253install_universal() {
254 #fix silly permissions in tarball
255 cd ${WORKDIR}
256 chown -R root:root *
257 chmod -R a+r-w+X,u+w *
258 cd ${OLDPWD}
259}
260
261install_headers() {
262 local ddir=$(kernel_header_destdir)
263
264 cd ${S}
265 dodir ${ddir}/linux
266 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux
267 rm -rf ${D}/${ddir}/linux/modules
268
269 # Handle multilib headers
270 case $(tc-arch-kernel) in
271 sparc64)
272 dodir ${ddir}/asm-sparc
273 cp -ax ${S}/include/asm-sparc/* ${D}/${ddir}/asm-sparc
274
275 dodir ${ddir}/asm-sparc64
276 cp -ax ${S}/include/asm-sparc64/* ${D}/${ddir}/asm-sparc64
277
278 create_ml_includes ${ddir}/asm !__arch64__:${ddir}/asm-sparc __arch64__:${ddir}/asm-sparc64
279 ;;
280 x86_64)
281 dodir ${ddir}/asm-i386
282 cp -ax ${S}/include/asm-i386/* ${D}/${ddir}/asm-i386
283
284 dodir ${ddir}/asm-x86_64
285 cp -ax ${S}/include/asm-x86_64/* ${D}/${ddir}/asm-x86_64
286
287 create_ml_includes ${ddir}/asm __i386__:${ddir}/asm-i386 __x86_64__:${ddir}/asm-x86_64
288 ;;
289 *)
290 dodir ${ddir}/asm
291 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm
292 ;;
293 esac
294
295 if kernel_is 2 6; then
296 dodir ${ddir}/asm-generic
297 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic
298 fi
299
300 # clean up
301 find "${D}" -name '*.orig' -exec rm -f {} \;
302
303 cd ${OLDPWD}
304}
305
306install_sources() {
307 local doc docs file
308
309 cd ${S}
310 dodir /usr/src
311 echo ">>> Copying sources ..."
312
313 file="$(find ${WORKDIR} -iname "docs" -type d)"
314 if [[ -n ${file} ]]; then
315 for file in $(find ${file} -type f); do
316 echo "${file//*docs\/}" >> ${S}/patches.txt
317 echo "===================================================" >> ${S}/patches.txt
318 cat ${file} >> ${S}/patches.txt
319 echo "===================================================" >> ${S}/patches.txt
320 echo "" >> ${S}/patches.txt
321 done
322 fi
323
324 if [[ ! -f ${S}/patches.txt ]]; then
325 # patches.txt is empty so lets use our ChangeLog
326 [[ -f ${FILESDIR}/../ChangeLog ]] && \
327 echo "Please check the ebuild ChangeLog for more details." \
328 > ${S}/patches.txt
329 fi
330
331 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
332 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
333 use doc && ! use arm && ! use s390 && install_manpages
334 dodoc ${docs}
335
336 mv ${WORKDIR}/linux* ${D}/usr/src
337}
338
339install_manpages() {
340 sed -ie "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
341 ebegin "Installing manpages"
342 env -u ARCH make installmandocs
343 eend $?
344 sed -ie "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
345}
346
347# pkg_preinst functions
348#==============================================================
349preinst_headers() {
350 local ddir=$(kernel_header_destdir)
351 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
352 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
353}
354
355# pkg_postinst functions
356#==============================================================
357postinst_sources() {
358 local MAKELINK=0
359
360 # if we have USE=symlink, then force K_SYMLINK=1
361 use symlink && K_SYMLINK=1
362
363 # if we are to forcably symlink, delete it if it already exists first.
364 if [[ -n ${K_SYMLINK} ]]; then
365 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
366 MAKELINK=1
367 fi
368
369 # if the link doesnt exist, lets create it
370 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
371
372 if [[ ${MAKELINK} == 1 ]]; then
373 cd ${ROOT}usr/src
374 ln -sf linux-${KV_FULL} linux
375 cd ${OLDPWD}
376 fi
377
378 # Don't forget to make directory for sysfs
379 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir /sys
380
381 echo
382 einfo "After installing a new kernel of any version, it is important"
383 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
384 einfo "created (X.Y is the first 2 parts of your new kernel version)"
385 echo
386 einfo "For example, this kernel will require:"
387 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
388 echo
389
390 # if K_EXTRAEINFO is set then lets display it now
391 if [[ -n ${K_EXTRAEINFO} ]]; then
392 echo ${K_EXTRAEINFO} | fmt |
393 while read -s ELINE; do einfo "${ELINE}"; done
394 fi
395
396 # if K_EXTRAEWARN is set then lets display it now
397 if [[ -n ${K_EXTRAEWARN} ]]; then
398 echo ${K_EXTRAEWARN} | fmt |
399 while read -s ELINE; do ewarn "${ELINE}"; done
400 fi
401}
402
403postinst_headers() {
404 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation"
405 einfo "of newer headers, it is advised that you re-merge glibc as follows:"
406 einfo "emerge glibc"
407 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel"
408 einfo "headers."
409}
410
411# pkg_setup functions
412#==============================================================
413setup_headers() {
414 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
415 for i in ${H_SUPPORTEDARCH}; do
416 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
417 done
418
419 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
420 echo
421 eerror "This version of ${PN} does not support ${ARCH}."
422 eerror "Please merge the appropriate sources, in most cases"
423 eerror "(but not all) this will be called ${ARCH}-headers."
424 die "Package unsupported for ${ARCH}"
425 fi
426}
427
428# unipatch
429#==============================================================
430unipatch() {
431 local i x extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
432 local STRICT_COUNT PATCH_LEVEL myLC_ALL
433
434 # set to a standard locale to ensure sorts are ordered properly.
435 myLC_ALL="${LC_ALL}"
436 LC_ALL="C"
437
438 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
439 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
440
441 # We're gonna need it when doing patches with a predefined patchlevel
442 shopt -s extglob
443
444 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
445 # usage can be either via an env var or by params
446 # although due to the nature we pass this within this eclass
447 # it shall be by param only.
448 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
449 UNIPATCH_LIST="${@}"
450
451 #unpack any passed tarballs
452 for i in ${UNIPATCH_LIST}; do
453 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then
454 extention=${i/*./}
455 extention=${extention/:*/}
456 case ${extention} in
457 tbz2) PIPE_CMD="tar -xvjf";;
458 bz2) PIPE_CMD="tar -xvjf";;
459 tgz) PIPE_CMD="tar -xvzf";;
460 gz) PIPE_CMD="tar -xvzf";;
461 *) eerror "Unrecognized tarball compression"
462 die "Unrecognized tarball compression";;
463 esac
464
465 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
466 STRICT_COUNT=$((${STRICT_COUNT} + 1))
467 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/
468 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${STRICT_COUNT}/ 1>/dev/null
469 else
470 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null
471 fi
472
473 if [ $? == 0 ]; then
474 einfo "${i/*\//} unpacked"
475 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
476 else
477 eerror "Failed to unpack ${i/:*/}"
478 die "unable to unpack patch tarball"
479 fi
480 else
481 extention=${i/*./}
482 extention=${extention/:*/}
483 PIPE_CMD=""
484 case ${extention} in
485 bz2) PIPE_CMD="bzip2 -dc";;
486 patch) PIPE_CMD="cat";;
487 diff) PIPE_CMD="cat";;
488 gz|Z|z) PIPE_CMD="gzip -dc";;
489 ZIP|zip) PIPE_CMD="unzip -p";;
490 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
491 esac
492
493 PATCH_LEVEL=${i/*([^:])?(:)}
494 i=${i/:*/}
495 x=${i/*\//}
496 x=${x/\.${extention}/}
497
498 if [ -n "${PIPE_CMD}" ]; then
499 if [ ! -r "${i}" ]; then
500 echo
501 eerror "FATAL: unable to locate:"
502 eerror "${i}"
503 eerror "for read-only. The file either has incorrect permissions"
504 eerror "or does not exist."
505 die Unable to locate ${i}
506 fi
507
508 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
509 STRICT_COUNT=$((${STRICT_COUNT} + 1))
510 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/
511 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${STRICT_COUNT}/${x}.patch${PATCH_LEVEL})
512 else
513 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL})
514 fi
515 fi
516 fi
517 done
518
519 #populate KPATCH_DIRS so we know where to look to remove the excludes
520 x=${KPATCH_DIR}
521 KPATCH_DIR=""
522 for i in $(find ${x} -type d | sort -n); do
523 KPATCH_DIR="${KPATCH_DIR} ${i}"
524 done
525
526 #so now lets get rid of the patchno's we want to exclude
527 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
528 for i in ${UNIPATCH_DROP}; do
529 ebegin "Excluding Patch #${i}"
530 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
531 eend $?
532 done
533
534 # and now, finally, we patch it :)
535 for x in ${KPATCH_DIR}; do
536 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
537 STDERR_T="${T}/${i/*\//}"
538 STDERR_T="${STDERR_T/.patch*/.err}"
539
540 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
541 [ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
542
543 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
544
545 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
546 while [ ${PATCH_DEPTH} -lt 5 ]; do
547 echo "Attempting Dry-run:" >> ${STDERR_T}
548 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T}
549 echo "=======================================================" >> ${STDERR_T}
550 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
551 echo "Attempting patch:" > ${STDERR_T}
552 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T}
553 echo "=======================================================" >> ${STDERR_T}
554 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
555 eend 0
556 rm ${STDERR_T}
557 break
558 else
559 eend 1
560 eerror "Failed to apply patch ${i/*\//}"
561 eerror "Please attach ${STDERR_T} to any bug you may post."
562 die "Failed to apply ${i/*\//}"
563 fi
564 else
565 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
566 fi
567 done
568 if [ ${PATCH_DEPTH} -eq 5 ]; then
569 eend 1
570 eerror "Please attach ${STDERR_T} to any bug you may post."
571 die "Unable to dry-run patch."
572 fi
573 done
574 done
575
576 # clean up KPATCH_DIR's - fixes bug #53610
577 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
578
579 LC_ALL="${myLC_ALL}"
580}
581
582# getfilevar accepts 2 vars as follows:
583# getfilevar <VARIABLE> <CONFIGFILE>
584# pulled from linux-info
585
586getfilevar() {
587 local workingdir basefname basedname xarch=$(tc-arch-kernel)
588
589 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
590 ebeep
591 echo -e "\n"
592 eerror "getfilevar requires 2 variables, with the second a valid file."
593 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
594 else
595 workingdir=${PWD}
596 basefname=$(basename ${2})
597 basedname=$(dirname ${2})
598 unset ARCH
599
600 cd ${basedname}
601 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
602 make ${BUILD_FIXES} -f - e 2>/dev/null
603 cd ${workingdir}
604
605 ARCH=${xarch}
606 fi
607} 146}
608 147
609detect_version() { 148detect_version() {
610 # this function will detect and set 149 # this function will detect and set
611 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 150 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
612 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 151 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
613 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 152 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
614 153
615 if [[ -n ${KV_FULL} ]]; then 154 # We've already run, so nothing to do here.
616 # we will set this for backwards compatibility. 155 [[ -n ${KV_FULL} ]] && return 0
617 KV=${KV_FULL}
618
619 # we know KV_FULL so lets stop here. but not without resetting S
620 S=${WORKDIR}/linux-${KV_FULL}
621 return
622 fi
623 156
624 # CKV is used as a comparison kernel version, which is used when 157 # CKV is used as a comparison kernel version, which is used when
625 # PV doesnt reflect the genuine kernel version. 158 # PV doesnt reflect the genuine kernel version.
626 # this gets set to the portage style versioning. ie: 159 # this gets set to the portage style versioning. ie:
627 # CKV=2.6.11_rc4 160 # CKV=2.6.11_rc4
631 OKV=${OKV/_rc/-rc} 164 OKV=${OKV/_rc/-rc}
632 OKV=${OKV/-r*} 165 OKV=${OKV/-r*}
633 OKV=${OKV/_p*} 166 OKV=${OKV/_p*}
634 167
635 KV_MAJOR=$(get_version_component_range 1 ${OKV}) 168 KV_MAJOR=$(get_version_component_range 1 ${OKV})
169 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
170 local OKV_ARRAY
171 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
172
173 # if KV_MAJOR >= 3, then we have no more KV_MINOR
174 #if [[ ${KV_MAJOR} -lt 3 ]]; then
175 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
636 KV_MINOR=$(get_version_component_range 2 ${OKV}) 176 KV_MINOR=$(get_version_component_range 2 ${OKV})
177 KV_PATCH=$(get_version_component_range 3 ${OKV})
178 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
179 KV_EXTRA=$(get_version_component_range 4- ${OKV})
180 KV_EXTRA=${KV_EXTRA/[-_]*}
181 else
637 KV_PATCH=$(get_version_component_range 3- ${OKV}) 182 KV_PATCH=$(get_version_component_range 3- ${OKV})
183 fi
184 else
185 KV_PATCH=$(get_version_component_range 2 ${OKV})
186 KV_EXTRA=$(get_version_component_range 3- ${OKV})
187 KV_EXTRA=${KV_EXTRA/[-_]*}
188 fi
189
190 debug-print "KV_EXTRA is ${KV_EXTRA}"
191
638 KV_PATCH=${KV_PATCH/[-_]*} 192 KV_PATCH=${KV_PATCH/[-_]*}
639 193
194 local v n=0 missing
195 #if [[ ${KV_MAJOR} -lt 3 ]]; then
196 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
197 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
198 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
199 done
200 else
201 for v in CKV OKV KV_{MAJOR,PATCH} ; do
202 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
203 done
204 fi
205
206 [[ $n -eq 1 ]] && \
207 eerror "Missing variables: ${missing}" && \
208 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
209 unset v n missing
210
211# if [[ ${KV_MAJOR} -ge 3 ]]; then
212 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
213 KV_PATCH_ARR=(${KV_PATCH//\./ })
214
215 # at this point 031412, Linus is putting all 3.x kernels in a
216 # 3.x directory, may need to revisit when 4.x is released
217 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
218
219 [[ -n "${K_LONGTERM}" ]] &&
220 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
221 else
222 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
640 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 223 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
224 if [[ ${KV_MAJOR} -ge 3 ]]; then
225 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
226 else
227 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
228 fi
229
230 [[ -n "${K_LONGTERM}" ]] &&
231 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
232 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
233 fi
234
235 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
236
237 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
238 # handle non genpatch using sources correctly
239 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
240 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
241 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
242 fi
243 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
244 else
245 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
246 fi
641 247
642 RELEASE=${CKV/${OKV}} 248 RELEASE=${CKV/${OKV}}
643 RELEASE=${RELEASE/_beta} 249 RELEASE=${RELEASE/_beta}
644 RELEASE=${RELEASE/_rc/-rc} 250 RELEASE=${RELEASE/_rc/-rc}
645 RELEASE=${RELEASE/_pre/-pre} 251 RELEASE=${RELEASE/_pre/-pre}
252 # We cannot trivally call kernel_is here, because it calls us to detect the
253 # version
646 kernel_is_2_6 && RELEASE=${RELEASE/-pre/-bk} 254 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
255 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
647 RELEASETYPE=${RELEASE//[0-9]} 256 RELEASETYPE=${RELEASE//[0-9]}
648 257
649 # Now we know that RELEASE is the -rc/-bk 258 # Now we know that RELEASE is the -rc/-git
650 # and RELEASETYPE is the same but with its numerics stripped 259 # and RELEASETYPE is the same but with its numerics stripped
651 # we can work on better sorting EXTRAVERSION. 260 # we can work on better sorting EXTRAVERSION.
652 # first of all, we add the release 261 # first of all, we add the release
653 EXTRAVERSION="${RELEASE}" 262 EXTRAVERSION="${RELEASE}"
263 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
264 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
654 265
266 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
267 if [[ -n "${K_NOUSEPR}" ]]; then
268 # Don't add anything based on PR to EXTRAVERSION
269 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
655 if [[ -n ${K_PREPATCHED} ]]; then 270 elif [[ -n ${K_PREPATCHED} ]]; then
271 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
656 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 272 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
657 elif [[ "${ETYPE}" = "sources" ]]; then 273 elif [[ "${ETYPE}" = "sources" ]]; then
274 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
658 # For some sources we want to use the PV in the extra version 275 # For some sources we want to use the PV in the extra version
659 # This is because upstream releases with a completely different 276 # This is because upstream releases with a completely different
660 # versioning scheme. 277 # versioning scheme.
661 case ${PN/-*} in 278 case ${PN/-*} in
662 wolk) K_USEPV=1;; 279 wolk) K_USEPV=1;;
663 vserver) K_USEPV=1;; 280 vserver) K_USEPV=1;;
664 esac 281 esac
665 282
666 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 283 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
667 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 284 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
668 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 285 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
286 fi
287 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
288
289 # The only messing around which should actually effect this is for KV_EXTRA
290 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
291 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
292
293 if [[ -n ${KV_EXTRA} ]]; then
294 if [[ -n ${KV_MINOR} ]]; then
295 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
296 else
297 OKV="${KV_MAJOR}.${KV_PATCH}"
669 fi 298 fi
299 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
300 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
301 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
302 fi
670 303
304 # We need to set this using OKV, but we need to set it before we do any
305 # messing around with OKV based on RELEASETYPE
671 KV_FULL=${OKV}${EXTRAVERSION} 306 KV_FULL=${OKV}${EXTRAVERSION}
672 307
308 # we will set this for backwards compatibility.
309 S=${WORKDIR}/linux-${KV_FULL}
310 KV=${KV_FULL}
311
673 # -rc-bk pulls can be achieved by specifying CKV 312 # -rc-git pulls can be achieved by specifying CKV
674 # for example: 313 # for example:
675 # CKV="2.6.11_rc3_pre2" 314 # CKV="2.6.11_rc3_pre2"
676 # will pull: 315 # will pull:
677 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2 316 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
678 317
318 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
319
679 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 320 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
680 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 321 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
681 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 322 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
682 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 323 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
683 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 324 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
684 fi 325 fi
685 326
686 if [[ ${RELEASETYPE} == -bk ]]; then 327 if [[ ${RELEASETYPE} == -git ]]; then
687 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 328 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
688 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 329 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
689 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 330 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
690 fi 331 fi
691 332
692 if [[ ${RELEASETYPE} == -rc-bk ]]; then 333 if [[ ${RELEASETYPE} == -rc-git ]]; then
693 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 334 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
694 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 335 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
695 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 336 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
696 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 337 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
338
697 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 339 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
698 fi 340 fi
341 else
342 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
343 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
344 OKV="2.6.39"
345 else
346 KV_PATCH_ARR=(${KV_PATCH//\./ })
347 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
348 fi
349 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
350 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
351 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
352 fi
699 353
700 # we will set this for backwards compatibility. 354 if [[ ${RELEASETYPE} == -git ]]; then
701 S=${WORKDIR}/linux-${KV_FULL} 355 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
702 KV=${KV_FULL} 356 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
357 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
358 fi
359
360 if [[ ${RELEASETYPE} == -rc-git ]]; then
361 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
362 OKV="2.6.39"
363 else
364 KV_PATCH_ARR=(${KV_PATCH//\./ })
365 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
366 fi
367 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
368 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
369 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
370
371 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
372 fi
373
374
375 fi
376
377
378 debug-print-kernel2-variables
379
380 handle_genpatches
381}
382
383# Note: duplicated in linux-info.eclass
384kernel_is() {
385 # ALL of these should be set before we can safely continue this function.
386 # some of the sources have in the past had only one set.
387 local v n=0
388 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
389 [[ $n -eq 1 ]] && detect_version
390 unset v n
391
392 # Now we can continue
393 local operator test value
394
395 case ${1#-} in
396 lt) operator="-lt"; shift;;
397 gt) operator="-gt"; shift;;
398 le) operator="-le"; shift;;
399 ge) operator="-ge"; shift;;
400 eq) operator="-eq"; shift;;
401 *) operator="-eq";;
402 esac
403 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
404
405 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
406 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
407 [ ${test} ${operator} ${value} ]
408}
409
410kernel_is_2_4() {
411 kernel_is 2 4
412}
413
414kernel_is_2_6() {
415 kernel_is 2 6 || kernel_is 2 5
416}
417
418# Capture the sources type and set DEPENDs
419if [[ ${ETYPE} == sources ]]; then
420 DEPEND="!build? ( sys-apps/sed
421 >=sys-devel/binutils-2.11.90.0.31 )"
422 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
423 sys-devel/make
424 dev-lang/perl
425 sys-devel/bc )"
426 PDEPEND="!build? ( virtual/dev-manager )"
427
428 SLOT="${PVR}"
429 DESCRIPTION="Sources based on the Linux Kernel."
430 IUSE="symlink build"
431
432 # Bug #266157, deblob for libre support
433 if [[ -z ${K_PREDEBLOBBED} ]] ; then
434 # Bug #359865, force a call to detect_version if needed
435 kernel_is ge 2 6 27 && \
436 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
437 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
438 K_DEBLOB_AVAILABLE=1
439 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
440 IUSE="${IUSE} deblob"
441 # Reflect that kernels contain firmware blobs unless otherwise
442 # stripped
443 LICENSE="${LICENSE} !deblob? ( freedist )"
444
445 if [[ -n KV_MINOR ]]; then
446 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
447 else
448 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
449 fi
450
451 if [[ ${KV_MAJOR} -ge 3 ]]; then
452 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
453 fi
454
455 DEBLOB_A="deblob-${DEBLOB_PV}"
456 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
457 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
458 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
459 if ! has "${EAPI:-0}" 0 1 ; then
460 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
461 else
462 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
463 fi
464 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
465 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
466
467 DEPEND+=" deblob? ( =dev-lang/python-2* )"
468 KERNEL_URI="${KERNEL_URI}
469 deblob? (
470 ${DEBLOB_URI}
471 ${DEBLOB_CHECK_URI}
472 )"
473 else
474 # We have no way to deblob older kernels, so just mark them as
475 # tainted with non-libre materials.
476 LICENSE="${LICENSE} freedist"
477 fi
478 fi
479
480elif [[ ${ETYPE} == headers ]]; then
481 DESCRIPTION="Linux system headers"
482
483 # Since we should NOT honour KBUILD_OUTPUT in headers
484 # lets unset it here.
485 unset KBUILD_OUTPUT
486
487 SLOT="0"
488else
489 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
490 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
491fi
492
493# Cross-compile support functions
494#==============================================================
495kernel_header_destdir() {
496 [[ ${CTARGET} == ${CHOST} ]] \
497 && echo /usr/include \
498 || echo /usr/${CTARGET}/usr/include
499}
500
501cross_pre_c_headers() {
502 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
503}
504
505env_setup_xmakeopts() {
506 # Kernel ARCH != portage ARCH
507 export KARCH=$(tc-arch-kernel)
508
509 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
510 # variables properly or bad things happen !
511 xmakeopts="ARCH=${KARCH}"
512 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
513 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
514 elif type -p ${CHOST}-ar > /dev/null ; then
515 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
516 fi
517 export xmakeopts
518}
519
520# Unpack functions
521#==============================================================
522unpack_2_4() {
523 # this file is required for other things to build properly,
524 # so we autogenerate it
525 make -s mrproper ${xmakeopts} || die "make mrproper failed"
526 make -s symlinks ${xmakeopts} || die "make symlinks failed"
527 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
528 echo ">>> version.h compiled successfully."
529}
530
531unpack_2_6() {
532 # this file is required for other things to build properly, so we
533 # autogenerate it ... generate a .config to keep version.h build from
534 # spitting out an annoying warning
535 make -s mrproper ${xmakeopts} 2>/dev/null \
536 || die "make mrproper failed"
537
538 # quick fix for bug #132152 which triggers when it cannot include linux
539 # headers (ie, we have not installed it yet)
540 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
541 touch .config
542 eerror "make defconfig failed."
543 eerror "assuming you dont have any headers installed yet and continuing"
544 epause 5
545 fi
546
547 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
548 || die "make include/linux/version.h failed"
549 rm -f .config >/dev/null
550}
551
552universal_unpack() {
553 debug-print "Inside universal_unpack"
554
555 local OKV_ARRAY
556 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
557
558 cd "${WORKDIR}"
559 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
560 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
561 else
562 unpack linux-${OKV}.tar.xz
563 fi
564
565 if [[ -d "linux" ]]; then
566 debug-print "Moving linux to linux-${KV_FULL}"
567 mv linux linux-${KV_FULL} \
568 || die "Unable to move source tree to ${KV_FULL}."
569 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
570 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
571 [[ "${ETYPE}" = "sources" ]]; then
572 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
573 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
574 || die "Unable to move source tree to ${KV_FULL}."
575 else
576 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
577 mv linux-${OKV} linux-${KV_FULL} \
578 || die "Unable to move source tree to ${KV_FULL}."
579 fi
580 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
581 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
582 || die "Unable to move source tree to ${KV_FULL}."
583 fi
584 cd "${S}"
585
586 # remove all backup files
587 find . -iname "*~" -exec rm {} \; 2> /dev/null
588
589}
590
591unpack_set_extraversion() {
592 cd "${S}"
593 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
594 cd "${OLDPWD}"
595}
596
597# Should be done after patches have been applied
598# Otherwise patches that modify the same area of Makefile will fail
599unpack_fix_install_path() {
600 cd "${S}"
601 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
602}
603
604# Compile Functions
605#==============================================================
606compile_headers() {
607 env_setup_xmakeopts
608
609 # if we couldnt obtain HOSTCFLAGS from the Makefile,
610 # then set it to something sane
611 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
612 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
613
614 if kernel_is 2 4; then
615 yes "" | make oldconfig ${xmakeopts}
616 echo ">>> make oldconfig complete"
617 make dep ${xmakeopts}
618 elif kernel_is 2 6; then
619 # 2.6.18 introduces headers_install which means we dont need any
620 # of this crap anymore :D
621 kernel_is ge 2 6 18 && return 0
622
623 # autoconf.h isnt generated unless it already exists. plus, we have
624 # no guarantee that any headers are installed on the system...
625 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
626 || touch include/linux/autoconf.h
627
628 # if K_DEFCONFIG isn't set, force to "defconfig"
629 # needed by mips
630 if [[ -z ${K_DEFCONFIG} ]]; then
631 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
632 case ${CTARGET} in
633 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
634 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
635 *) K_DEFCONFIG="defconfig";;
636 esac
637 else
638 K_DEFCONFIG="defconfig"
639 fi
640 fi
641
642 # if there arent any installed headers, then there also isnt an asm
643 # symlink in /usr/include/, and make defconfig will fail, so we have
644 # to force an include path with $S.
645 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
646 ln -sf asm-${KARCH} "${S}"/include/asm
647 cross_pre_c_headers && return 0
648
649 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
650 if compile_headers_tweak_config ; then
651 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
652 fi
653 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
654 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
655 fi
656}
657
658compile_headers_tweak_config() {
659 # some targets can be very very picky, so let's finesse the
660 # .config based upon any info we may have
661 case ${CTARGET} in
662 sh*)
663 sed -i '/CONFIG_CPU_SH/d' .config
664 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
665 return 0;;
666 esac
667
668 # no changes, so lets do nothing
669 return 1
670}
671
672# install functions
673#==============================================================
674install_universal() {
675 # Fix silly permissions in tarball
676 cd "${WORKDIR}"
677 chown -R 0:0 * >& /dev/null
678 chmod -R a+r-w+X,u+w *
679 cd ${OLDPWD}
680}
681
682install_headers() {
683 local ddir=$(kernel_header_destdir)
684
685 # 2.6.18 introduces headers_install which means we dont need any
686 # of this crap anymore :D
687 if kernel_is ge 2 6 18 ; then
688 env_setup_xmakeopts
689 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
690
691 # let other packages install some of these headers
692 rm -rf "${D}"/${ddir}/sound #alsa-headers
693 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
694 return 0
695 fi
696
697 # Do not use "linux/*" as that can cause problems with very long
698 # $S values where the cmdline to cp is too long
699 pushd "${S}" >/dev/null
700 dodir ${ddir}/linux
701 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
702 rm -rf "${D}"/${ddir}/linux/modules
703
704 dodir ${ddir}/asm
705 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
706
707 if kernel_is 2 6 ; then
708 dodir ${ddir}/asm-generic
709 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
710 fi
711
712 # clean up
713 find "${D}" -name '*.orig' -exec rm -f {} \;
714
715 popd >/dev/null
716}
717
718install_sources() {
719 local file
720
721 cd "${S}"
722 dodir /usr/src
723 echo ">>> Copying sources ..."
724
725 file="$(find ${WORKDIR} -iname "docs" -type d)"
726 if [[ -n ${file} ]]; then
727 for file in $(find ${file} -type f); do
728 echo "${file//*docs\/}" >> "${S}"/patches.txt
729 echo "===================================================" >> "${S}"/patches.txt
730 cat ${file} >> "${S}"/patches.txt
731 echo "===================================================" >> "${S}"/patches.txt
732 echo "" >> "${S}"/patches.txt
733 done
734 fi
735
736 if [[ ! -f ${S}/patches.txt ]]; then
737 # patches.txt is empty so lets use our ChangeLog
738 [[ -f ${FILESDIR}/../ChangeLog ]] && \
739 echo "Please check the ebuild ChangeLog for more details." \
740 > "${S}"/patches.txt
741 fi
742
743 mv ${WORKDIR}/linux* "${D}"/usr/src
744
745 if [[ -z ${UNIPATCH_DOCS} ]] ; then
746 dodoc ${UNIPATCH_DOCS}
747 fi
748}
749
750# pkg_preinst functions
751#==============================================================
752preinst_headers() {
753 local ddir=$(kernel_header_destdir)
754 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
755 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
756}
757
758# pkg_postinst functions
759#==============================================================
760postinst_sources() {
761 local MAKELINK=0
762
763 # if we have USE=symlink, then force K_SYMLINK=1
764 use symlink && K_SYMLINK=1
765
766 # if we're using a deblobbed kernel, it's not supported
767 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
768 use deblob && \
769 K_SECURITY_UNSUPPORTED=deblob
770
771 # if we are to forcably symlink, delete it if it already exists first.
772 if [[ ${K_SYMLINK} > 0 ]]; then
773 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
774 MAKELINK=1
775 fi
776
777 # if the link doesnt exist, lets create it
778 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
779
780 if [[ ${MAKELINK} == 1 ]]; then
781 cd "${ROOT}"usr/src
782 ln -sf linux-${KV_FULL} linux
783 cd ${OLDPWD}
784 fi
785
786 # Don't forget to make directory for sysfs
787 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
788
789 echo
790 elog "If you are upgrading from a previous kernel, you may be interested"
791 elog "in the following document:"
792 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
793 echo
794
795 # if K_EXTRAEINFO is set then lets display it now
796 if [[ -n ${K_EXTRAEINFO} ]]; then
797 echo ${K_EXTRAEINFO} | fmt |
798 while read -s ELINE; do einfo "${ELINE}"; done
799 fi
800
801 # if K_EXTRAELOG is set then lets display it now
802 if [[ -n ${K_EXTRAELOG} ]]; then
803 echo ${K_EXTRAELOG} | fmt |
804 while read -s ELINE; do elog "${ELINE}"; done
805 fi
806
807 # if K_EXTRAEWARN is set then lets display it now
808 if [[ -n ${K_EXTRAEWARN} ]]; then
809 echo ${K_EXTRAEWARN} | fmt |
810 while read -s ELINE; do ewarn "${ELINE}"; done
811 fi
812
813 # optionally display security unsupported message
814 # Start with why
815 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
816 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
817 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
818 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
819 fi
820 # And now the general message.
821 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
822 ewarn "This means that it is likely to be vulnerable to recent security issues."
823 ewarn "For specific information on why this kernel is unsupported, please read:"
824 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
825 fi
826
827 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
828 KV_MAJOR=$(get_version_component_range 1 ${OKV})
829 KV_MINOR=$(get_version_component_range 2 ${OKV})
830 KV_PATCH=$(get_version_component_range 3 ${OKV})
831 if [[ "$(tc-arch)" = "sparc" ]]; then
832 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
833 then
834 echo
835 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
836 elog "you now need to do"
837 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
838 elog "instead of just"
839 elog " make"
840 elog "to compile the kernel. For more information please browse to"
841 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
842 echo
843 fi
844 fi
845}
846
847# pkg_setup functions
848#==============================================================
849setup_headers() {
850 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
851 for i in ${H_SUPPORTEDARCH}; do
852 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
853 done
854
855 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
856 echo
857 eerror "This version of ${PN} does not support $(tc-arch)."
858 eerror "Please merge the appropriate sources, in most cases"
859 eerror "(but not all) this will be called $(tc-arch)-headers."
860 die "Package unsupported for $(tc-arch)"
861 fi
862}
863
864# unipatch
865#==============================================================
866unipatch() {
867 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
868 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
869
870 # set to a standard locale to ensure sorts are ordered properly.
871 myLC_ALL="${LC_ALL}"
872 myLANG="${LANG}"
873 LC_ALL="C"
874 LANG=""
875
876 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
877 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
878
879 # We're gonna need it when doing patches with a predefined patchlevel
880 eshopts_push -s extglob
881
882 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
883 # usage can be either via an env var or by params
884 # although due to the nature we pass this within this eclass
885 # it shall be by param only.
886 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
887 UNIPATCH_LIST="${@}"
888
889 #unpack any passed tarballs
890 for i in ${UNIPATCH_LIST}; do
891 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
892 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
893 unset z
894 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
895 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
896 do z="${z}0";
897 done
898 PATCH_ORDER="${z}${STRICT_COUNT}"
899
900 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
901 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
902 unpack ${i##*/}
903 popd >/dev/null
904 else
905 pushd "${KPATCH_DIR}" >/dev/null
906 unpack ${i##*/}
907 popd >/dev/null
908 fi
909
910 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
911 else
912 extention=${i/*./}
913 extention=${extention/:*/}
914 PIPE_CMD=""
915 case ${extention} in
916 xz) PIPE_CMD="xz -dc";;
917 lzma) PIPE_CMD="lzma -dc";;
918 bz2) PIPE_CMD="bzip2 -dc";;
919 patch) PIPE_CMD="cat";;
920 diff) PIPE_CMD="cat";;
921 gz|Z|z) PIPE_CMD="gzip -dc";;
922 ZIP|zip) PIPE_CMD="unzip -p";;
923 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
924 esac
925
926 PATCH_LEVEL=${i/*([^:])?(:)}
927 i=${i/:*/}
928 x=${i/*\//}
929 x=${x/\.${extention}/}
930
931 if [ -n "${PIPE_CMD}" ]; then
932 if [ ! -r "${i}" ]; then
933 echo
934 eerror "FATAL: unable to locate:"
935 eerror "${i}"
936 eerror "for read-only. The file either has incorrect permissions"
937 eerror "or does not exist."
938 die Unable to locate ${i}
939 fi
940
941 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
942 unset z
943 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
944 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
945 do z="${z}0";
946 done
947 PATCH_ORDER="${z}${STRICT_COUNT}"
948
949 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
950 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
951 else
952 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
953 fi
954 fi
955 fi
956 done
957
958 #populate KPATCH_DIRS so we know where to look to remove the excludes
959 x=${KPATCH_DIR}
960 KPATCH_DIR=""
961 for i in $(find ${x} -type d | sort -n); do
962 KPATCH_DIR="${KPATCH_DIR} ${i}"
963 done
964
965 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
966 # bug #272676
967 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
968 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
969 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
970 echo
971 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
972 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
973 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
974 echo
975 fi
976 fi
977
978 #so now lets get rid of the patchno's we want to exclude
979 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
980 for i in ${UNIPATCH_DROP}; do
981 ebegin "Excluding Patch #${i}"
982 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
983 eend $?
984 done
985
986 # and now, finally, we patch it :)
987 for x in ${KPATCH_DIR}; do
988 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
989 STDERR_T="${T}/${i/*\//}"
990 STDERR_T="${STDERR_T/.patch*/.err}"
991
992 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
993 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
994
995 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
996
997 while [ ${PATCH_DEPTH} -lt 5 ]; do
998 echo "Attempting Dry-run:" >> ${STDERR_T}
999 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
1000 echo "=======================================================" >> ${STDERR_T}
1001 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1002 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
1003 echo "Attempting patch:" > ${STDERR_T}
1004 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
1005 echo "=======================================================" >> ${STDERR_T}
1006 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1007 eend 0
1008 rm ${STDERR_T}
1009 break
1010 else
1011 eend 1
1012 eerror "Failed to apply patch ${i/*\//}"
1013 eerror "Please attach ${STDERR_T} to any bug you may post."
1014 eshopts_pop
1015 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
1016 fi
1017 else
1018 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
1019 fi
1020 done
1021 if [ ${PATCH_DEPTH} -eq 5 ]; then
1022 eerror "Failed to dry-run patch ${i/*\//}"
1023 eerror "Please attach ${STDERR_T} to any bug you may post."
1024 eshopts_pop
1025 die "Unable to dry-run patch on any patch depth lower than 5."
1026 fi
1027 done
1028 done
1029
1030 # When genpatches is used, we want to install 0000_README which documents
1031 # the patches that were used; such that the user can see them, bug #301478.
1032 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
1033 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
1034 fi
1035
1036 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
1037 # to the temporary directory and remember them in UNIPATCH_DOCS to install
1038 # them during the install phase.
1039 local tmp
1040 for x in ${KPATCH_DIR}; do
1041 for i in ${UNIPATCH_DOCS}; do
1042 if [[ -f "${x}/${i}" ]] ; then
1043 tmp="${tmp} \"${T}/${i}\""
1044 cp -f "${x}/${i}" "${T}"/
1045 fi
1046 done
1047 done
1048 UNIPATCH_DOCS="${tmp}"
1049
1050 # clean up KPATCH_DIR's - fixes bug #53610
1051 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1052
1053 LC_ALL="${myLC_ALL}"
1054 LANG="${myLANG}"
1055 eshopts_pop
1056}
1057
1058# getfilevar accepts 2 vars as follows:
1059# getfilevar <VARIABLE> <CONFIGFILE>
1060# pulled from linux-info
1061
1062getfilevar() {
1063 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1064
1065 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1066 echo -e "\n"
1067 eerror "getfilevar requires 2 variables, with the second a valid file."
1068 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1069 else
1070 workingdir=${PWD}
1071 basefname=$(basename ${2})
1072 basedname=$(dirname ${2})
1073 unset ARCH
1074
1075 cd ${basedname}
1076 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1077 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1078 cd ${workingdir}
1079
1080 ARCH=${xarch}
1081 fi
703} 1082}
704 1083
705detect_arch() { 1084detect_arch() {
706 # This function sets ARCH_URI and ARCH_PATCH 1085 # This function sets ARCH_URI and ARCH_PATCH
707 # with the neccessary info for the arch sepecific compatibility 1086 # with the neccessary info for the arch sepecific compatibility
713 # ARCH_URI is the URI for all the ${ARCH}_URI patches 1092 # ARCH_URI is the URI for all the ${ARCH}_URI patches
714 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 1093 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
715 1094
716 ARCH_URI="" 1095 ARCH_URI=""
717 ARCH_PATCH="" 1096 ARCH_PATCH=""
718 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 1097 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
719 1098
720 for LOOP_ARCH in ${ALL_ARCH}; do 1099 for LOOP_ARCH in ${ALL_ARCH}; do
721 COMPAT_URI="${LOOP_ARCH}_URI" 1100 COMPAT_URI="${LOOP_ARCH}_URI"
722 COMPAT_URI="${!COMPAT_URI}" 1101 COMPAT_URI="${!COMPAT_URI}"
723 1102
730 done 1109 done
731 fi 1110 fi
732 done 1111 done
733} 1112}
734 1113
735# sparc nastiness
736#==============================================================
737# This script generates the files in /usr/include/asm for sparc systems
738# during installation of sys-kernel/linux-headers.
739# Will no longer be needed when full 64 bit support is used on sparc64
740# systems.
741#
742# Shamefully ripped from Debian
743# ----------------------------------------------------------------------
744
745# Idea borrowed from RedHat's kernel package
746
747# This is gonna get replaced by something in multilib.eclass soon...
748# --eradicator
749generate_sparc_asm() {
750 local name
751
752 cd $1 || die
753 mkdir asm
754
755 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
756 name="$(echo $h | tr a-z. A-Z_)"
757 # common header
758 echo "/* All asm/ files are generated and point to the corresponding
759 * file in asm-sparc or asm-sparc64.
760 */
761
762#ifndef __SPARCSTUB__${name}__
763#define __SPARCSTUB__${name}__
764" > asm/${h}
765
766 # common for sparc and sparc64
767 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
768 echo "#ifdef __arch64__
769#include <asm-sparc64/$h>
770#else
771#include <asm-sparc/$h>
772#endif
773" >> asm/${h}
774
775 # sparc only
776 elif [ -f asm-sparc/$h ]; then
777echo "#ifndef __arch64__
778#include <asm-sparc/$h>
779#endif
780" >> asm/${h}
781
782 # sparc64 only
783 else
784echo "#ifdef __arch64__
785#include <asm-sparc64/$h>
786#endif
787" >> asm/${h}
788 fi
789
790 # common footer
791 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
792 done
793 return 0
794}
795
796headers___fix() { 1114headers___fix() {
797 # Voodoo to partially fix broken upstream headers. 1115 # Voodoo to partially fix broken upstream headers.
798 # Issues with this function should go to plasmaroo. 1116 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
799 sed -i \ 1117 sed -i \
800 -e "s/\([ "$'\t'"]\)u8\([ "$'\t'"]\)/\1__u8\2/g;" \ 1118 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
801 -e "s/\([ "$'\t'"]\)u16\([ "$'\t'"]\)/\1__u16\2/g;" \
802 -e "s/\([ "$'\t'"]\)u32\([ "$'\t'"]\)/\1__u32\2/g;" \
803 -e "s/\([ "$'\t'"]\)u64\([ "$'\t'"]\)/\1__u64\2/g;" \
804 -e "s/\([ "$'\t'"]\)s64\([ "$'\t'"]\)/\1__s64\2/g;" \
805 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1119 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
806 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1120 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1121 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1122 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
807 "$@" 1123 "$@"
808} 1124}
809 1125
810# common functions 1126# common functions
811#============================================================== 1127#==============================================================
812kernel-2_src_unpack() { 1128kernel-2_src_unpack() {
813 universal_unpack 1129 universal_unpack
1130 debug-print "Doing unipatch"
814 1131
815 [[ -n ${UNIPATCH_LIST} ]] || [[ -n ${UNIPATCH_LIST_DEFAULT} ]] && \ 1132 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
816 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1133 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
817 1134
818 [ -z "${K_NOSETEXTRAVERSION}" ] && \ 1135 debug-print "Doing premake"
819 unpack_set_extraversion
820 1136
1137 # allow ebuilds to massage the source tree after patching but before
1138 # we run misc `make` functions below
1139 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1140
1141 debug-print "Doing epatch_user"
1142 epatch_user
1143
1144 debug-print "Doing unpack_set_extraversion"
1145
1146 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
821 unpack_fix_install_path 1147 unpack_fix_install_path
822 1148
1149 # Setup xmakeopts and cd into sourcetree.
1150 env_setup_xmakeopts
1151 cd "${S}"
1152
1153 # We dont need a version.h for anything other than headers
1154 # at least, I should hope we dont. If this causes problems
1155 # take out the if/fi block and inform me please.
1156 # unpack_2_6 should now be 2.6.17 safe anyways
1157 if [[ ${ETYPE} == headers ]]; then
823 kernel_is 2 4 && unpack_2_4 1158 kernel_is 2 4 && unpack_2_4
1159 kernel_is 2 6 && unpack_2_6
1160 fi
1161
1162 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1163 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1164 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1165 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1166 fi
1167
1168 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1169 # only do this for kernel < 2.6.27 since this file does not exist in later
1170 # kernels
1171 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
1172 then
1173 sed -i \
1174 -e "s|TOUT := .tmp_gas_check|TOUT := \"${T}\"/.tmp_gas_check|" \
1175 "${S}"/arch/ppc/Makefile
1176 else
1177 sed -i \
1178 -e "s|TOUT := .tmp_gas_check|TOUT := \"${T}\"/.tmp_gas_check|" \
1179 "${S}"/arch/powerpc/Makefile
1180 fi
824} 1181}
825 1182
826kernel-2_src_compile() { 1183kernel-2_src_compile() {
827 cd ${S} 1184 cd "${S}"
828 [[ ${ETYPE} == headers ]] && compile_headers 1185 [[ ${ETYPE} == headers ]] && compile_headers
829 [[ ${ETYPE} == sources ]] && \ 1186
830 use doc && ! use arm && ! use s390 && compile_manpages 1187 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1188 echo ">>> Running deblob script ..."
1189 EPYTHON="python2" sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1190 fi
831} 1191}
1192
1193# if you leave it to the default src_test, it will run make to
1194# find whether test/check targets are present; since "make test"
1195# actually produces a few support files, they are installed even
1196# though the package is binchecks-restricted.
1197#
1198# Avoid this altogether by making the function moot.
1199kernel-2_src_test() { :; }
832 1200
833kernel-2_pkg_preinst() { 1201kernel-2_pkg_preinst() {
834 [[ ${ETYPE} == headers ]] && preinst_headers 1202 [[ ${ETYPE} == headers ]] && preinst_headers
835} 1203}
836 1204
839 [[ ${ETYPE} == headers ]] && install_headers 1207 [[ ${ETYPE} == headers ]] && install_headers
840 [[ ${ETYPE} == sources ]] && install_sources 1208 [[ ${ETYPE} == sources ]] && install_sources
841} 1209}
842 1210
843kernel-2_pkg_postinst() { 1211kernel-2_pkg_postinst() {
844 [[ ${ETYPE} == headers ]] && postinst_headers
845 [[ ${ETYPE} == sources ]] && postinst_sources 1212 [[ ${ETYPE} == sources ]] && postinst_sources
846} 1213}
847 1214
848kernel-2_pkg_setup() { 1215kernel-2_pkg_setup() {
1216 if kernel_is 2 4; then
1217 if [[ $(gcc-major-version) -ge 4 ]] ; then
1218 echo
1219 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1220 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1221 ewarn "newer kernel that supports gcc-4."
1222 echo
1223 ewarn "Also be aware that bugreports about gcc-4 not working"
1224 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1225 echo
1226 epause 10
1227 fi
1228 fi
1229
1230 ABI="${KERNEL_ABI}"
849 [[ ${ETYPE} == headers ]] && setup_headers 1231 [[ ${ETYPE} == headers ]] && setup_headers
850 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1232 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
851} 1233}
1234
1235kernel-2_pkg_postrm() {
1236 # This warning only makes sense for kernel sources.
1237 [[ ${ETYPE} == headers ]] && return 0
1238
1239 # If there isn't anything left behind, then don't complain.
1240 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1241 echo
1242 ewarn "Note: Even though you have successfully unmerged "
1243 ewarn "your kernel package, directories in kernel source location: "
1244 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1245 ewarn "with modified files will remain behind. By design, package managers"
1246 ewarn "will not remove these modified files and the directories they reside in."
1247 echo
1248}

Legend:
Removed from v.1.105  
changed lines
  Added in v.1.282

  ViewVC Help
Powered by ViewVC 1.1.20